var documenterSearchIndex = {"docs":
[{"location":"index.html#BayesSizeAndShape","page":"BayesSizeAndShape","title":"BayesSizeAndShape","text":"","category":"section"},{"location":"index.html#Package-Features","page":"BayesSizeAndShape","title":"Package Features","text":"","category":"section"},{"location":"index.html#Function-Documentation","page":"BayesSizeAndShape","title":"Function Documentation","text":"","category":"section"},{"location":"index.html","page":"BayesSizeAndShape","title":"BayesSizeAndShape","text":"SizeAndShapeWithReflectionMCMC","category":"page"},{"location":"index.html#BayesSizeAndShape.SizeAndShapeWithReflectionMCMC","page":"BayesSizeAndShape","title":"BayesSizeAndShape.SizeAndShapeWithReflectionMCMC","text":"SizeAndShapeWithReflectionMCMC(\n    landmarks::Array{Float64,3}, \n    fm::FormulaTerm,\n    covariates::DataFrame, \n    iterations::NamedTuple{(:iter, :burnin, :thin),Tuple{Int64,Int64,Int64}},\n    betaprior::ContinuousUnivariateDistribution,\n    sigmaprior::ContinuousMatrixDistribution\n)\n\nPosterior samples from the size-and-shape model - in this version, only two-dimensional data with reflection information are allowed. \nThe functions returns an object of type  SizeAndShapeModelOutput.\n\nArguments\n\nLet \n\nn be the number of objects;\nk+1 be the number of recorded landmark for each object\np be the dimension of each landmark (only p=2 or p=3)\n\nThe arguments of the functions are \n\nlandmarks: a three-dimensional  Array of dimension (k+1)times p times n  with the data; \nfm:  a formula, where on the left-hand side there must be 1 and on the right-hand side there is the actual regressive formula - an intercept is needed;\ncovariates: a DataFrame of covariates. The formula fm search for the covariates in the DataFrame column names;\niterations: a NamedTuple with iter, burnin, and thin values of the MCMC algorithm\nbetaprior:  a Normal distribution that is used as prior for all regressive coefficients\nsigmaprior: an InverseWishart distribution that is used as prior for the covariance matrix.\n\n\n\n\n\n","category":"function"},{"location":"index.html","page":"BayesSizeAndShape","title":"BayesSizeAndShape","text":"sizeshape_helmertproduct_reflection","category":"page"},{"location":"index.html#BayesSizeAndShape.sizeshape_helmertproduct_reflection","page":"BayesSizeAndShape","title":"BayesSizeAndShape.sizeshape_helmertproduct_reflection","text":"sizeshape_helmertproduct_reflection(dataset::Array{Float64,3})\n\nThe function computes the Size-And-Shape version of the data dataset, with reflection information.  The output is computed using the helmert matrix and the SVD trasformation\n\n\n\n\n\n","category":"function"},{"location":"index.html#Posterior-Samples","page":"BayesSizeAndShape","title":"Posterior Samples","text":"","category":"section"},{"location":"index.html","page":"BayesSizeAndShape","title":"BayesSizeAndShape","text":"posterior_samples_sigma\nposterior_samples_beta","category":"page"},{"location":"index.html#BayesSizeAndShape.posterior_samples_sigma","page":"BayesSizeAndShape","title":"BayesSizeAndShape.posterior_samples_sigma","text":"posterior_samples_sigma(modeloutput::SizeAndShapeModelOutput{KeepReflection,RL,P,DoNotRemoveSize,GramSchmidtMean,<:MCMCNormalDataKeepSize,<:LinearMean,<:MCMCLinearMean,CT,CM,PS}) where {\n    RL<:RemoveLocation,\n    CT<:TypeModelCoVariance,\n    CM<:MCMCTypeModelCoVariance,\n    PS<:MCMCObjectOUT,\n    P<:ValueP\n    }\n\nThe function extract the posterior sample of the covariance matrix from an object of type SizeAndShapeModelOutput   \n\n\n\n\n\n","category":"function"},{"location":"index.html#BayesSizeAndShape.posterior_samples_beta","page":"BayesSizeAndShape","title":"BayesSizeAndShape.posterior_samples_beta","text":"posterior_samples_beta(modeloutput::SizeAndShapeModelOutput{KeepReflection,RL,P,DoNotRemoveSize,GramSchmidtMean,<:MCMCNormalDataKeepSize,<:LinearMean,<:MCMCLinearMean,CT,CM,PS}) where {\n    RL<:RemoveLocation,\n    CT<:TypeModelCoVariance,\n    CM<:MCMCTypeModelCoVariance,\n    PS<:MCMCObjectOUT,\n    P<:ValueP   \n}\n\nThe function extract the posterior sample of the regressive coefficients from an object of type SizeAndShapeModelOutput \n\n\n\n\n\n","category":"function"}]
}
